const tilePixelSize = 32;

const scaleFactor = 0.25;

const textureAtlas = {
  closed: [0, 6],
  flag: [1, 6],
  flagWin: [2, 6],
  flagWrong: [3, 6],
  mineClosed:[4, 6],
  mineOpen: [5, 6],
  mineFlagged: [6, 6],
  open: (n) => [n & 7, (n & 56) >> 3],
};

var resources = {
  tiles: glUtil.loadTexture(b64Images.tiles),
};

var shaders = {
  nodeShader: null,
  edgeShader: null,
};

let program1 = glUtil.shader.loadCombined(shaderSource.node_vertex, shaderSource.node_fragment);
shaders.nodeShader = {
  program: program1,
  attribLocations: {
    position: gl.getAttribLocation(program1, 'aPos'),
    texCoord: gl.getAttribLocation(program1, 'aTexCoord'),
    nodeId: gl.getAttribLocation(program1, 'aNodeId'),
  },
  uniformLocations: {
    fieldSize: gl.getUniformLocation(program1, 'uFieldSize'),
    texture: gl.getUniformLocation(program1, 'uTexture'),
    tileLocations: gl.getUniformLocation(program1, 'uTileLocations')
  },
};

let program2 = glUtil.shader.loadCombined(shaderSource.edge_vertex, shaderSource.edge_fragment);
shaders.edgeShader = {
  program: program2,
  attribLocations: {
    position: gl.getAttribLocation(program2, 'aPos'),
    nodeIds: gl.getAttribLocation(program2, 'aNodeIds'),
  },
  uniformLocations: {
    fieldSize: gl.getUniformLocation(program2, 'uFieldSize'),
    highlight: gl.getUniformLocation(program2, 'highlightedNode'),
  },
};
