var isRunning = false;

function startLoop(){
  if(isRunning) return;
  isRunning = true;
  window.requestAnimationFrame(loop);
}

function loop(){
  // Check if the loop should exit
  if(!isRunning) return;
  // ===== Body of the loop =====
  // Handle the timer
  if(validMineField){
    switch(mineField.gameState){
      case 0:
        setTimer(0);
        break;
      case 1:
        setTimer((new Date()).getTime() - timerValue);
        break;
      case 2:
      case 3:
        setTimer(timerValue);
        break;
    }
  }else{
    setTimer(0);
  }
  // Check if the mouse hovers over a node
  if(mousePosition.changed){
    let n = mineField.parseClickedNode(
      mousePosition.x - canvas.getBoundingClientRect().left - 1 - window.pageXOffset,
      mousePosition.y  - canvas.getBoundingClientRect().top - 1 - window.pageYOffset);
    selectHighlight(n);
  }
  // Done dealing with the mouse position
  mousePosition.changed = false;
  // Call it again on the next frame
  window.requestAnimationFrame(loop);
}

var timerDisplay = document.getElementById("timer");
var lastCounterTime = -1;

function setTimer(time){
  if(lastCounterTime == time) return;
  lastCounterTime = time;
  let ms = time % 1000;
  time /= 1000;
  let sec = time % 60;
  time = Math.floor(time / 60);
  sec = Math.floor(sec);
  if(ms < 100){
    if(ms < 10){
      ms = "0" + ms;
    }
    ms = "0" + ms;
  }
  if(sec < 10){
    sec = "0" + sec;
  }
  timerDisplay.innerText = time + ":" + sec + "." + ms;
}

var mousePosition = {x: 0, y: 0, changed: false};

if(!isMobile){
  document.onmousemove = function(event){
    if((mousePosition.x == event.pageX) && (mousePosition.y == event.pageY)) return;
    mousePosition.x = event.pageX;
    mousePosition.y = event.pageY;
    mousePosition.changed = true;
  };
};

// Start for the first time
generateNewGame(recentGenerator);
startLoop();
window.requestAnimationFrame(draw);
// Draw some extra times to prevent the texture not loading in time
setTimeout(draw, 50);
setTimeout(draw, 100);
setTimeout(draw, 150);
setTimeout(draw, 200);
setTimeout(draw, 300);
setTimeout(draw, 500);
setTimeout(draw, 750);
setTimeout(draw, 1000);
setTimeout(draw, 1500);
setTimeout(draw, 2000);
