const shaderSource = {

node_vertex :
`
attribute vec2 aPos;
attribute vec2 aTexCoord;
attribute float aNodeId;
    
uniform vec2 uFieldSize;
uniform float uTileLocations[` + setting_maxNodesStrX2 + `];

varying highp vec2 vTexCoord;

void main(void) {
  int nId = int(aNodeId);
  gl_Position = vec4(
    2.0 * aPos.x / uFieldSize.x - 1.0,
    - 2.0 * aPos.y / uFieldSize.y + 1.0,
    0.0, 1.0);
  vTexCoord = vec2(aTexCoord.x + uTileLocations[nId * 2], aTexCoord.y + uTileLocations[nId * 2 + 1]);
}
`,

node_fragment:
`
varying highp vec2 vTexCoord;

uniform sampler2D uTexture;

void main(void) {
  highp vec4 col = texture2D(uTexture, vTexCoord);
    
  //col = vec4(1.0,1.0,0.0,1.0);
  if(col.a < 0.5) discard;

  gl_FragColor = col;
}
`,

edge_vertex:
`
attribute vec2 aPos;
attribute vec2 aNodeIds;
    
uniform vec2 uFieldSize;

uniform float highlightedNode;

varying lowp float isHighlighted;

void main(void) {
  
  if((highlightedNode == aNodeIds.x)
    || (highlightedNode == aNodeIds.y)){
    isHighlighted = 1.0;
  }else{
    isHighlighted = 0.0;
  }
  
  gl_Position = vec4(
    2.0 * aPos.x / uFieldSize.x - 1.0,
    - 2.0 * aPos.y / uFieldSize.y + 1.0,
    0.0, 1.0);
}
`,

edge_fragment:
`
varying lowp float isHighlighted;

void main(void) {
  lowp float x = (isHighlighted > 0.0) ? 0.6 : 0.0;
  
  highp vec4 col = vec4(0.25 + x,0.35,0.35,1.0);

  gl_FragColor = col;
}
`,

}
