const vecUtil = {
  // Normalize a vector
  normalize: (vIn) => {
    let l = 0;
    for(x of vIn){
      l += x * x;
    }
    l = 1 / Math.sqrt(l);
    let vRet = [];
    for(let i = 0; i < vIn.length; i++){
      vRet.push(l * vIn[i]);
    }
    return vRet;
  },
  // Dot product
  dot: (vInA, vInB) => {
    let l = Math.min(vInA.length, vInB.length);
    let r = 0;
    for(let i = 0; i < l; i++){
      r += vInA[i] * vInB[i];
    }
    return r;
  },
  // Multiply a vector with a scalar
  mult_v_s: (vIn, sIn) => {
    vRet = [];
    for(let i = 0; i < vIn.length; i++){
      vRet.push(vIn[i] * sIn);
    }
    return vRet;
  },
}
